﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace RealTime130177
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ObservableCollection<double> frequencies;
        double startFreq = 200;
        double stepFreq = 20;
        double stopFreq = 1000;
        bool canUpdate;
        public MainWindow()
        {
            InitializeComponent();
            frequencies = new ObservableCollection<double>();
            CalculateFrequency();
            listView.ItemsSource = new ObservableCollection<double>();
        }
        
        void CalculateFrequency()
        {
            while (startFreq <= stopFreq)
            {
                frequencies.Add(startFreq);           
                startFreq += stepFreq;
            }
        }

        private void btnStep_Click(object sender, RoutedEventArgs e)
        {
            mainFunc();
        }

       async void mainFunc()
        {
            for (int i = 0; i < frequencies.Count; i++)
            {
                double foundAmp = 0;
                bool isPointFound = findPointInAmplitude(frequencies[i], ref foundAmp);
                if (isPointFound)
                {
                    (listView.ItemsSource as ObservableCollection<double>).Add(foundAmp);
                }
                else
                {
                    (listView.ItemsSource as ObservableCollection<double>).Add(foundAmp);
                }

             // If you uncommand the code the ListView ItemsSource Items takes time to update the Items.
              // await Task.Delay(500);
            }
        }

        bool findPointInAmplitude(double frequency, ref double foundAmp)
        {
            double startAmp = 0;
            double endAmp = 20;
            const double stepAmp = 0.2;
            bool pointFound = false;
            while (endAmp - startAmp >= stepAmp)
            {
                double meanAmp = (endAmp + startAmp) / 2;

                int status = getStatusFromRemoteMachine();
                if (status == 1)
                {
                    endAmp = meanAmp;
                    pointFound = true;
                }
                else
                {
                    startAmp = meanAmp;
                }
            }
            if (pointFound)
            {
                foundAmp = endAmp;
            }
            return pointFound;
        }

        private int getStatusFromRemoteMachine()
        {
            canUpdate = !canUpdate;
            if (canUpdate)
                return 1;
            else
                return 0;
        }
    }   
}
